*** ./src/backend/optimizer/prep/preptlist.c.orig	2010-07-28 09:37:12.000000000 +0100
--- ./src/backend/optimizer/prep/preptlist.c	2010-08-15 09:35:45.000000000 +0100
***************
*** 38,44 ****
  
  
  static List *expand_targetlist(List *tlist, int command_type,
! 				  Index result_relation, List *range_table);
  
  
  /*
--- 38,44 ----
  
  
  static List *expand_targetlist(List *tlist, int command_type,
! 				  Index result_relation, Relation rel);
  
  
  /*
***************
*** 52,57 ****
--- 52,58 ----
  {
  	Query	   *parse = root->parse;
  	int			result_relation = parse->resultRelation;
+ 	bool		result_is_view = false;
  	List	   *range_table = parse->rtable;
  	CmdType		command_type = parse->commandType;
  	ListCell   *lc;
***************
*** 63,81 ****
  	if (result_relation)
  	{
  		RangeTblEntry *rte = rt_fetch(result_relation, range_table);
  
  		if (rte->subquery != NULL || rte->relid == InvalidOid)
  			elog(ERROR, "subquery cannot be result relation");
  	}
  
  	/*
! 	 * for heap_form_tuple to work, the targetlist must match the exact order
! 	 * of the attributes. We also need to fill in any missing attributes. -ay
! 	 * 10/94
  	 */
! 	if (command_type == CMD_INSERT || command_type == CMD_UPDATE)
! 		tlist = expand_targetlist(tlist, command_type,
! 								  result_relation, range_table);
  
  	/*
  	 * for "update" and "delete" queries, add ctid of the result relation into
--- 64,100 ----
  	if (result_relation)
  	{
  		RangeTblEntry *rte = rt_fetch(result_relation, range_table);
+ 		Relation	rel;
  
  		if (rte->subquery != NULL || rte->relid == InvalidOid)
  			elog(ERROR, "subquery cannot be result relation");
+ 
+ 		/*
+ 		 * Open the result relation.  We assume that the rewriter already
+ 		 * acquired at least AccessShareLock on it, so we need no lock here.
+ 		 */
+ 		rel = heap_open(getrelid(result_relation, range_table), NoLock);
+ 		result_is_view = rel->rd_rel->relkind == RELKIND_VIEW;
+ 
+ 		/*
+ 		 * for heap_form_tuple to work, the targetlist must match the exact
+ 		 * order of the attributes. We also need to fill in any missing
+ 		 * attributes. -ay 10/94
+ 		 */
+ 		if (command_type == CMD_INSERT || command_type == CMD_UPDATE)
+ 			tlist = expand_targetlist(tlist, command_type,
+ 									  result_relation, rel);
+ 
+ 		heap_close(rel, NoLock);
  	}
  
  	/*
! 	 * For an UPDATE, expand_targetlist already created a fresh tlist. For
! 	 * DELETE, better do a listCopy so that we don't destructively modify
! 	 * the original tlist (is this really necessary?).
  	 */
! 	if (command_type == CMD_DELETE)
! 		tlist = list_copy(tlist);
  
  	/*
  	 * for "update" and "delete" queries, add ctid of the result relation into
***************
*** 83,90 ****
  	 * ExecutePlan() will be able to identify the right tuple to replace or
  	 * delete.	This extra field is marked "junk" so that it is not stored
  	 * back into the tuple.
  	 */
! 	if (command_type == CMD_UPDATE || command_type == CMD_DELETE)
  	{
  		TargetEntry *tle;
  		Var		   *var;
--- 102,114 ----
  	 * ExecutePlan() will be able to identify the right tuple to replace or
  	 * delete.	This extra field is marked "junk" so that it is not stored
  	 * back into the tuple.
+ 	 *
+ 	 * We don't do this if the result relation is a view, since that won't
+ 	 * expose a ctid. The rewriter should have already added a wholerow TLE
+ 	 * for the view's subselect.
  	 */
! 	if (!result_is_view &&
! 		(command_type == CMD_UPDATE || command_type == CMD_DELETE))
  	{
  		TargetEntry *tle;
  		Var		   *var;
***************
*** 97,110 ****
  							  pstrdup("ctid"),
  							  true);
  
- 		/*
- 		 * For an UPDATE, expand_targetlist already created a fresh tlist. For
- 		 * DELETE, better do a listCopy so that we don't destructively modify
- 		 * the original tlist (is this really necessary?).
- 		 */
- 		if (command_type == CMD_DELETE)
- 			tlist = list_copy(tlist);
- 
  		tlist = lappend(tlist, tle);
  	}
  
--- 121,126 ----
***************
*** 169,187 ****
  		}
  		else
  		{
! 			/* Not a table, so we need the whole row as a junk var */
! 			var = makeVar(rc->rti,
! 						  InvalidAttrNumber,
! 						  RECORDOID,
! 						  -1,
! 						  0);
! 			snprintf(resname, sizeof(resname), "wholerow%u", rc->rti);
! 			tle = makeTargetEntry((Expr *) var,
! 								  list_length(tlist) + 1,
! 								  pstrdup(resname),
! 								  true);
! 			tlist = lappend(tlist, tle);
! 			rc->wholeAttNo = tle->resno;
  		}
  	}
  
--- 185,227 ----
  		}
  		else
  		{
! 			bool		exists = false;
! 			ListCell   *l;
! 
! 			/*
! 			 * Not a table, so we need the whole row as a junk var. If the
! 			 * query target is a view, the rewriter will have already added
! 			 * a whole row var, so don't add another for that RTE.
! 			 */
! 			foreach(l, tlist)
! 			{
! 				TargetEntry	   *tle = (TargetEntry *) lfirst(l);
! 
! 				if (tle->resjunk &&
! 					IsA(tle->expr, Var) &&
! 					((Var *) tle->expr)->varno == rc->rti &&
! 					strcmp(tle->resname, "wholerow") == 0)
! 				{
! 					exists = true;
! 					break;
! 				}
! 			}
! 
! 			if (!exists)
! 			{
! 				var = makeVar(rc->rti,
! 							  InvalidAttrNumber,
! 							  RECORDOID,
! 							  -1,
! 							  0);
! 				snprintf(resname, sizeof(resname), "wholerow%u", rc->rti);
! 				tle = makeTargetEntry((Expr *) var,
! 									  list_length(tlist) + 1,
! 									  pstrdup(resname),
! 									  true);
! 				tlist = lappend(tlist, tle);
! 				rc->wholeAttNo = tle->resno;
! 			}
  		}
  	}
  
***************
*** 241,251 ****
   */
  static List *
  expand_targetlist(List *tlist, int command_type,
! 				  Index result_relation, List *range_table)
  {
  	List	   *new_tlist = NIL;
  	ListCell   *tlist_item;
- 	Relation	rel;
  	int			attrno,
  				numattrs;
  
--- 281,290 ----
   */
  static List *
  expand_targetlist(List *tlist, int command_type,
! 				  Index result_relation, Relation rel)
  {
  	List	   *new_tlist = NIL;
  	ListCell   *tlist_item;
  	int			attrno,
  				numattrs;
  
***************
*** 256,267 ****
  	 * order; but we have to insert TLEs for any missing attributes.
  	 *
  	 * Scan the tuple description in the relation's relcache entry to make
! 	 * sure we have all the user attributes in the right order.  We assume
! 	 * that the rewriter already acquired at least AccessShareLock on the
! 	 * relation, so we need no lock here.
  	 */
- 	rel = heap_open(getrelid(result_relation, range_table), NoLock);
- 
  	numattrs = RelationGetNumberOfAttributes(rel);
  
  	for (attrno = 1; attrno <= numattrs; attrno++)
--- 295,302 ----
  	 * order; but we have to insert TLEs for any missing attributes.
  	 *
  	 * Scan the tuple description in the relation's relcache entry to make
! 	 * sure we have all the user attributes in the right order.
  	 */
  	numattrs = RelationGetNumberOfAttributes(rel);
  
  	for (attrno = 1; attrno <= numattrs; attrno++)
***************
*** 399,406 ****
  		tlist_item = lnext(tlist_item);
  	}
  
- 	heap_close(rel, NoLock);
- 
  	return new_tlist;
  }
  
--- 434,439 ----
*** ./src/backend/optimizer/util/plancat.c.orig	2010-08-28 17:18:36.000000000 +0100
--- ./src/backend/optimizer/util/plancat.c	2010-08-28 17:18:35.000000000 +0100
***************
*** 441,447 ****
  			*tuples = 1;
  			break;
  		default:
! 			/* else it has no disk storage; probably shouldn't get here? */
  			*pages = 0;
  			*tuples = 0;
  			break;
--- 441,452 ----
  			*tuples = 1;
  			break;
  		default:
! 			/*
! 			 * Else it has no disk storage; probably shouldn't get here,
! 			 * unless this is a VIEW which is the query target, in which
! 			 * case we don't care about the sizes, since it will always be
! 			 * at the top of the plan tree.
! 			 */
  			*pages = 0;
  			*tuples = 0;
  			break;
*** ./src/backend/parser/gram.y.orig	2010-08-28 17:26:46.000000000 +0100
--- ./src/backend/parser/gram.y	2010-08-28 17:26:44.000000000 +0100
***************
*** 245,251 ****
  %type <str>		OptSchemaName
  %type <list>	OptSchemaEltList
  
! %type <boolean> TriggerActionTime TriggerForSpec opt_trusted opt_restart_seqs
  
  %type <list>	TriggerEvents TriggerOneEvent
  %type <value>	TriggerFuncArg
--- 245,252 ----
  %type <str>		OptSchemaName
  %type <list>	OptSchemaEltList
  
! %type <boolean> TriggerForSpec opt_trusted opt_restart_seqs
! %type <ival>	TriggerActionTime
  
  %type <list>	TriggerEvents TriggerOneEvent
  %type <value>	TriggerFuncArg
***************
*** 3377,3383 ****
  					n->relation = $7;
  					n->funcname = $12;
  					n->args = $14;
! 					n->before = $4;
  					n->row = $8;
  					n->events = intVal(linitial($5));
  					n->columns = (List *) lsecond($5);
--- 3378,3385 ----
  					n->relation = $7;
  					n->funcname = $12;
  					n->args = $14;
! 					n->before = ($4 & 1) != 0;
! 					n->instead = ($4 & 2) != 0;
  					n->row = $8;
  					n->events = intVal(linitial($5));
  					n->columns = (List *) lsecond($5);
***************
*** 3399,3404 ****
--- 3401,3407 ----
  					n->funcname = $17;
  					n->args = $19;
  					n->before = FALSE;
+ 					n->instead = FALSE;
  					n->row = TRUE;
  					n->events = intVal(linitial($6));
  					n->columns = (List *) lsecond($6);
***************
*** 3412,3419 ****
  		;
  
  TriggerActionTime:
! 			BEFORE									{ $$ = TRUE; }
! 			| AFTER									{ $$ = FALSE; }
  		;
  
  TriggerEvents:
--- 3415,3423 ----
  		;
  
  TriggerActionTime:
! 			BEFORE									{ $$ = 1; }
! 			| AFTER									{ $$ = 0; }
! 			| INSTEAD OF							{ $$ = 2; }
  		;
  
  TriggerEvents:
*** ./src/backend/rewrite/rewriteHandler.c.orig	2010-07-28 09:37:27.000000000 +0100
--- ./src/backend/rewrite/rewriteHandler.c	2010-08-15 09:07:20.000000000 +0100
***************
*** 564,570 ****
   * planner will later insert NULLs for them, but there's no reason to slow
   * down rewriter processing with extra tlist nodes.)  Also, for both INSERT
   * and UPDATE, replace explicit DEFAULT specifications with column default
!  * expressions.
   *
   * 2. Merge multiple entries for the same target attribute, or declare error
   * if we can't.  Multiple entries are only allowed for INSERT/UPDATE of
--- 564,572 ----
   * planner will later insert NULLs for them, but there's no reason to slow
   * down rewriter processing with extra tlist nodes.)  Also, for both INSERT
   * and UPDATE, replace explicit DEFAULT specifications with column default
!  * expressions.  For an UPDATE on a VIEW, add tlist entries assigning any
!  * unassigned attributes their current values.  The RHS of such assignments
!  * will be rewritten to refer to the view's subselect node.
   *
   * 2. Merge multiple entries for the same target attribute, or declare error
   * if we can't.  Multiple entries are only allowed for INSERT/UPDATE of
***************
*** 724,729 ****
--- 726,753 ----
  										  false);
  		}
  
+ 		/*
+ 		 * For an UPDATE on a VIEW where the TLE is missing, assign the
+ 		 * current value, which will be rewritten as a query from the view's
+ 		 * subselect node by ApplyRetrieveRule().
+ 		 */
+ 		if (new_tle == NULL && commandType == CMD_UPDATE &&
+ 			target_relation->rd_rel->relkind == RELKIND_VIEW)
+ 		{
+ 			Node	   *new_expr;
+ 
+ 			new_expr = (Node *) makeVar(parsetree->resultRelation,
+ 										attrno,
+ 										att_tup->atttypid,
+ 										att_tup->atttypmod,
+ 										0);
+ 
+ 			new_tle = makeTargetEntry((Expr *) new_expr,
+ 									  attrno,
+ 									  pstrdup(NameStr(att_tup->attname)),
+ 									  false);
+ 		}
+ 
  		if (new_tle)
  			new_tlist = lappend(new_tlist, new_tle);
  	}
***************
*** 1149,1154 ****
--- 1173,1180 ----
  	RangeTblEntry *rte,
  			   *subrte;
  	RowMarkClause *rc;
+ 	Var		   *var;
+ 	TargetEntry *tle;
  
  	if (list_length(rule->actions) != 1)
  		elog(ERROR, "expected just one rule action");
***************
*** 1177,1220 ****
  	 */
  	rule_action = fireRIRrules(rule_action, activeRIRs, forUpdatePushedDown);
  
! 	/*
! 	 * VIEWs are really easy --- just plug the view query in as a subselect,
! 	 * replacing the relation's original RTE.
! 	 */
! 	rte = rt_fetch(rt_index, parsetree->rtable);
  
! 	rte->rtekind = RTE_SUBQUERY;
! 	rte->relid = InvalidOid;
! 	rte->subquery = rule_action;
! 	rte->inh = false;			/* must not be set for a subquery */
  
! 	/*
! 	 * We move the view's permission check data down to its rangetable. The
! 	 * checks will actually be done against the OLD entry therein.
! 	 */
! 	subrte = rt_fetch(PRS2_OLD_VARNO, rule_action->rtable);
! 	Assert(subrte->relid == relation->rd_id);
! 	subrte->requiredPerms = rte->requiredPerms;
! 	subrte->checkAsUser = rte->checkAsUser;
! 	subrte->selectedCols = rte->selectedCols;
! 	subrte->modifiedCols = rte->modifiedCols;
! 
! 	rte->requiredPerms = 0;		/* no permission check on subquery itself */
! 	rte->checkAsUser = InvalidOid;
! 	rte->selectedCols = NULL;
! 	rte->modifiedCols = NULL;
  
! 	/*
! 	 * If FOR UPDATE/SHARE of view, mark all the contained tables as implicit
! 	 * FOR UPDATE/SHARE, the same as the parser would have done if the view's
! 	 * subquery had been written out explicitly.
! 	 *
! 	 * Note: we don't consider forUpdatePushedDown here; such marks will be
! 	 * made by recursing from the upper level in markQueryForLocking.
! 	 */
! 	if (rc != NULL)
! 		markQueryForLocking(rule_action, (Node *) rule_action->jointree,
! 							rc->forUpdate, rc->noWait, true);
  
  	return parsetree;
  }
--- 1203,1313 ----
  	 */
  	rule_action = fireRIRrules(rule_action, activeRIRs, forUpdatePushedDown);
  
! 	if (rt_index == parsetree->resultRelation)
! 	{
! 		/*
! 		 * We have a VIEW as the query target. For DELETE and UPDATE, we
! 		 * add a new subselect RTE using the view's query and adjust any
! 		 * VARs in the original query to point to this instead of the
! 		 * original view RTE.
! 		 *
! 		 * We keep the original view in the rtable as the query target, and
! 		 * any Vars in the returning list that reference it are left alone.
! 		 *
! 		 * The resulting jointree fromlist will not refer to the view RTE,
! 		 * and so the planner won't try to join to it. This will result in
! 		 * a plan with a ModifyTable node at the root, referring to the
! 		 * original view relation, and a subselect based on the view's query
! 		 * merged with any user conditions.
! 		 *
! 		 * For INSERTS we do nothing. The original view remains the query
! 		 * target.
! 		 */
! 		if (parsetree->commandType == CMD_DELETE ||
! 			parsetree->commandType == CMD_UPDATE)
! 		{
! 			List	*returningList = parsetree->returningList;
  
! 			/*
! 			 * Make a new subselect RTE from the view query and adjust the
! 			 * the original query to point to this instead of the original
! 			 * view, while preserving the view resultRelation and any
! 			 * returningList Vars.
! 			 */
! 			rte = copyObject(rt_fetch(rt_index, parsetree->rtable));
  
! 			rte->rtekind = RTE_SUBQUERY;
! 			rte->relid = InvalidOid;
! 			rte->subquery = rule_action;
! 			rte->inh = false;			/* must not be set for a subquery */
  
! 			parsetree->rtable = lappend(parsetree->rtable, rte);
! 			parsetree->returningList = NIL;
! 
! 			ChangeVarNodes((Node *) parsetree, rt_index,
! 						   list_length(parsetree->rtable), 0);
! 
! 			parsetree->resultRelation = rt_index;
! 			parsetree->returningList = returningList;
! 
! 			/*
! 			 * Add a "wholerow" junk TLE so that the executor can retrieve
! 			 * the old VIEW tuples to pass to the INSTEAD OF triggers.
! 			 */
! 			var = makeVar(list_length(parsetree->rtable),
! 						  InvalidAttrNumber,
! 						  RECORDOID,
! 						  -1,
! 						  0);
! 
! 			tle = makeTargetEntry((Expr *) var,
! 								  list_length(parsetree->targetList) + 1,
! 								  pstrdup("wholerow"),
! 								  true);
! 			parsetree->targetList = lappend(parsetree->targetList, tle);
! 		}
! 	}
! 	else
! 	{
! 		/*
! 		 * Selecting from the VIEW --- just plug the view query in as a
! 		 * subselect, replacing the relation's original RTE.
! 		 */
! 		rte = rt_fetch(rt_index, parsetree->rtable);
! 
! 		rte->rtekind = RTE_SUBQUERY;
! 		rte->relid = InvalidOid;
! 		rte->subquery = rule_action;
! 		rte->inh = false;			/* must not be set for a subquery */
! 
! 		/*
! 		 * We move the view's permission check data down to its rangetable.
! 		 * The checks will actually be done against the OLD entry therein.
! 		 */
! 		subrte = rt_fetch(PRS2_OLD_VARNO, rule_action->rtable);
! 		Assert(subrte->relid == relation->rd_id);
! 		subrte->requiredPerms = rte->requiredPerms;
! 		subrte->checkAsUser = rte->checkAsUser;
! 		subrte->selectedCols = rte->selectedCols;
! 		subrte->modifiedCols = rte->modifiedCols;
! 
! 		rte->requiredPerms = 0;	/* no permission check on subquery itself */
! 		rte->checkAsUser = InvalidOid;
! 		rte->selectedCols = NULL;
! 		rte->modifiedCols = NULL;
! 
! 		/*
! 		 * If FOR UPDATE/SHARE of view, mark all the contained tables as
! 		 * implicit FOR UPDATE/SHARE, the same as the parser would have done
! 		 * if the view's subquery had been written out explicitly.
! 		 *
! 		 * Note: we don't consider forUpdatePushedDown here; such marks will
! 		 * be made by recursing from the upper level in markQueryForLocking.
! 		 */
! 		if (rc != NULL)
! 			markQueryForLocking(rule_action, (Node *) rule_action->jointree,
! 								rc->forUpdate, rc->noWait, true);
! 	}
  
  	return parsetree;
  }
*** ./src/backend/utils/adt/ruleutils.c.orig	2010-08-15 00:14:30.000000000 +0100
--- ./src/backend/utils/adt/ruleutils.c	2010-08-15 10:45:04.000000000 +0100
***************
*** 545,550 ****
--- 545,552 ----
  
  	if (TRIGGER_FOR_BEFORE(trigrec->tgtype))
  		appendStringInfo(&buf, "BEFORE");
+ 	else if (TRIGGER_FOR_INSTEAD(trigrec->tgtype))
+ 		appendStringInfo(&buf, "INSTEAD OF");
  	else
  		appendStringInfo(&buf, "AFTER");
  	if (TRIGGER_FOR_INSERT(trigrec->tgtype))
*** ./src/backend/utils/adt/tsvector_op.c.orig	2010-08-15 00:18:37.000000000 +0100
--- ./src/backend/utils/adt/tsvector_op.c	2010-08-15 12:50:47.000000000 +0100
***************
*** 1259,1265 ****
  	trigdata = (TriggerData *) fcinfo->context;
  	if (TRIGGER_FIRED_FOR_STATEMENT(trigdata->tg_event))
  		elog(ERROR, "tsvector_update_trigger: can't process STATEMENT events");
! 	if (TRIGGER_FIRED_AFTER(trigdata->tg_event))
  		elog(ERROR, "tsvector_update_trigger: must be fired BEFORE event");
  
  	if (TRIGGER_FIRED_BY_INSERT(trigdata->tg_event))
--- 1259,1265 ----
  	trigdata = (TriggerData *) fcinfo->context;
  	if (TRIGGER_FIRED_FOR_STATEMENT(trigdata->tg_event))
  		elog(ERROR, "tsvector_update_trigger: can't process STATEMENT events");
! 	if (!TRIGGER_FIRED_BEFORE(trigdata->tg_event))
  		elog(ERROR, "tsvector_update_trigger: must be fired BEFORE event");
  
  	if (TRIGGER_FIRED_BY_INSERT(trigdata->tg_event))
*** ./src/bin/pg_dump/pg_dump.c.orig	2010-08-15 00:21:49.000000000 +0100
--- ./src/bin/pg_dump/pg_dump.c	2010-08-15 10:52:30.000000000 +0100
***************
*** 11745,11750 ****
--- 11745,11752 ----
  		findx = 0;
  		if (TRIGGER_FOR_BEFORE(tginfo->tgtype))
  			appendPQExpBuffer(query, "BEFORE");
+ 		if (TRIGGER_FOR_INSTEAD(tginfo->tgtype))
+ 			appendPQExpBuffer(query, "INSTEAD OF");
  		else
  			appendPQExpBuffer(query, "AFTER");
  		if (TRIGGER_FOR_INSERT(tginfo->tgtype))
*** ./src/bin/psql/describe.c.orig	2010-08-03 17:16:15.000000000 +0100
--- ./src/bin/psql/describe.c	2010-08-15 10:50:29.000000000 +0100
***************
*** 1820,1827 ****
--- 1820,1838 ----
  			}
  			PQclear(result);
  		}
+ 	}
  
+ 	/*
+ 	 * Print triggers next.
+ 	 * This is part of the footer information about a table, but may also
+ 	 * apply to a view.
+ 	 */
+ 	if (tableinfo.relkind == 'r' || tableinfo.relkind == 'v')
+ 	{
  		/* print triggers (but only user-defined triggers) */
+ 		PGresult   *result = NULL;
+ 		int			tuples = 0;
+ 
  		if (tableinfo.hastriggers)
  		{
  			printfPQExpBuffer(&buf,
***************
*** 1935,1942 ****
--- 1946,1963 ----
  			}
  			PQclear(result);
  		}
+ 	}
  
+ 	/*
+ 	 * Done printing trigger information for view or table.
+ 	 * Finish printing the footer information about a table.
+ 	 */
+ 	if (tableinfo.relkind == 'r')
+ 	{
  		/* print inherited tables */
+ 		PGresult   *result = NULL;
+ 		int			tuples = 0;
+ 
  		printfPQExpBuffer(&buf, "SELECT c.oid::pg_catalog.regclass FROM pg_catalog.pg_class c, pg_catalog.pg_inherits i WHERE c.oid=i.inhparent AND i.inhrelid = '%s' ORDER BY inhseqno", oid);
  
  		result = PSQLexec(buf.data, false);
*** ./src/include/catalog/pg_trigger.h.orig	2010-09-04 15:00:15.000000000 +0100
--- ./src/include/catalog/pg_trigger.h	2010-09-04 15:16:04.000000000 +0100
***************
*** 91,96 ****
--- 91,97 ----
  #define TRIGGER_TYPE_DELETE				(1 << 3)
  #define TRIGGER_TYPE_UPDATE				(1 << 4)
  #define TRIGGER_TYPE_TRUNCATE			(1 << 5)
+ #define TRIGGER_TYPE_INSTEAD			(1 << 6)
  
  /* Macros for manipulating tgtype */
  #define TRIGGER_CLEAR_TYPE(type)		((type) = 0)
***************
*** 101,106 ****
--- 102,108 ----
  #define TRIGGER_SETT_DELETE(type)		((type) |= TRIGGER_TYPE_DELETE)
  #define TRIGGER_SETT_UPDATE(type)		((type) |= TRIGGER_TYPE_UPDATE)
  #define TRIGGER_SETT_TRUNCATE(type)		((type) |= TRIGGER_TYPE_TRUNCATE)
+ #define TRIGGER_SETT_INSTEAD(type)		((type) |= TRIGGER_TYPE_INSTEAD)
  
  #define TRIGGER_FOR_ROW(type)			((type) & TRIGGER_TYPE_ROW)
  #define TRIGGER_FOR_BEFORE(type)		((type) & TRIGGER_TYPE_BEFORE)
***************
*** 108,112 ****
--- 110,115 ----
  #define TRIGGER_FOR_DELETE(type)		((type) & TRIGGER_TYPE_DELETE)
  #define TRIGGER_FOR_UPDATE(type)		((type) & TRIGGER_TYPE_UPDATE)
  #define TRIGGER_FOR_TRUNCATE(type)		((type) & TRIGGER_TYPE_TRUNCATE)
+ #define TRIGGER_FOR_INSTEAD(type)		((type) & TRIGGER_TYPE_INSTEAD)
  
  #endif   /* PG_TRIGGER_H */
*** ./src/include/commands/trigger.h.orig	2010-08-15 00:24:40.000000000 +0100
--- ./src/include/commands/trigger.h	2010-09-01 16:59:34.000000000 +0100
***************
*** 53,58 ****
--- 53,59 ----
  #define TRIGGER_EVENT_OPMASK			0x00000003
  #define TRIGGER_EVENT_ROW				0x00000004
  #define TRIGGER_EVENT_BEFORE			0x00000008
+ #define TRIGGER_EVENT_INSTEAD			0x00000040
  
  /* More TriggerEvent flags, used only within trigger.c */
  
***************
*** 84,91 ****
  #define TRIGGER_FIRED_BEFORE(event)				\
  		((TriggerEvent) (event) & TRIGGER_EVENT_BEFORE)
  
  #define TRIGGER_FIRED_AFTER(event)				\
! 		(!TRIGGER_FIRED_BEFORE (event))
  
  /*
   * Definitions for the replication role based firing.
--- 85,95 ----
  #define TRIGGER_FIRED_BEFORE(event)				\
  		((TriggerEvent) (event) & TRIGGER_EVENT_BEFORE)
  
+ #define TRIGGER_FIRED_INSTEAD(event)				\
+ 		((TriggerEvent) (event) & TRIGGER_EVENT_INSTEAD)
+ 
  #define TRIGGER_FIRED_AFTER(event)				\
! 		(!TRIGGER_FIRED_BEFORE (event) && !TRIGGER_FIRED_INSTEAD (event))
  
  /*
   * Definitions for the replication role based firing.
***************
*** 135,140 ****
--- 139,147 ----
  					 ResultRelInfo *relinfo,
  					 HeapTuple trigtuple,
  					 List *recheckIndexes);
+ extern HeapTuple ExecIRInsertTriggers(EState *estate,
+ 					 ResultRelInfo *relinfo,
+ 					 HeapTuple trigtuple);
  extern void ExecBSDeleteTriggers(EState *estate,
  					 ResultRelInfo *relinfo);
  extern void ExecASDeleteTriggers(EState *estate,
***************
*** 146,151 ****
--- 153,161 ----
  extern void ExecARDeleteTriggers(EState *estate,
  					 ResultRelInfo *relinfo,
  					 ItemPointer tupleid);
+ extern bool ExecIRDeleteTriggers(EState *estate,
+ 					 ResultRelInfo *relinfo,
+ 					 HeapTuple trigtuple);
  extern void ExecBSUpdateTriggers(EState *estate,
  					 ResultRelInfo *relinfo);
  extern void ExecASUpdateTriggers(EState *estate,
***************
*** 160,165 ****
--- 170,179 ----
  					 ItemPointer tupleid,
  					 HeapTuple newtuple,
  					 List *recheckIndexes);
+ extern HeapTuple ExecIRUpdateTriggers(EState *estate,
+ 					 ResultRelInfo *relinfo,
+ 					 HeapTuple oldtuple,
+ 					 HeapTuple newtuple);
  extern void ExecBSTruncateTriggers(EState *estate,
  					   ResultRelInfo *relinfo);
  extern void ExecASTruncateTriggers(EState *estate,
*** ./src/include/nodes/parsenodes.h.orig	2010-08-19 08:59:46.000000000 +0100
--- ./src/include/nodes/parsenodes.h	2010-08-19 08:59:45.000000000 +0100
***************
*** 1608,1613 ****
--- 1608,1614 ----
  	List	   *funcname;		/* qual. name of function to call */
  	List	   *args;			/* list of (T_String) Values or NIL */
  	bool		before;			/* BEFORE/AFTER */
+ 	bool		instead;		/* INSTEAD OF (overrides BEFORE/AFTER) */
  	bool		row;			/* ROW/STATEMENT */
  	/* events uses the TRIGGER_TYPE bits defined in catalog/pg_trigger.h */
  	int16		events;			/* INSERT/UPDATE/DELETE/TRUNCATE */
*** ./src/include/utils/rel.h.orig	2010-08-15 00:30:33.000000000 +0100
--- ./src/include/utils/rel.h	2010-08-15 10:20:43.000000000 +0100
***************
*** 82,91 ****
--- 82,93 ----
  	uint16		n_before_statement[TRIGGER_NUM_EVENT_CLASSES];
  	uint16		n_before_row[TRIGGER_NUM_EVENT_CLASSES];
  	uint16		n_after_row[TRIGGER_NUM_EVENT_CLASSES];
+ 	uint16		n_instead_row[TRIGGER_NUM_EVENT_CLASSES];
  	uint16		n_after_statement[TRIGGER_NUM_EVENT_CLASSES];
  	int		   *tg_before_statement[TRIGGER_NUM_EVENT_CLASSES];
  	int		   *tg_before_row[TRIGGER_NUM_EVENT_CLASSES];
  	int		   *tg_after_row[TRIGGER_NUM_EVENT_CLASSES];
+ 	int		   *tg_instead_row[TRIGGER_NUM_EVENT_CLASSES];
  	int		   *tg_after_statement[TRIGGER_NUM_EVENT_CLASSES];
  
  	/* The actual array of triggers is here */
*** ./src/pl/plperl/plperl.c.orig	2010-07-31 12:19:30.000000000 +0100
--- ./src/pl/plperl/plperl.c	2010-08-30 23:39:05.000000000 +0100
***************
*** 954,959 ****
--- 954,961 ----
  		when = "BEFORE";
  	else if (TRIGGER_FIRED_AFTER(tdata->tg_event))
  		when = "AFTER";
+ 	else if (TRIGGER_FIRED_INSTEAD(tdata->tg_event))
+ 		when = "INSTEAD OF";
  	else
  		when = "UNKNOWN";
  	hv_store_string(hv, "when", newSVstring(when));
*** ./src/pl/plperl/sql/plperl_trigger.sql.orig	2010-09-04 10:57:46.000000000 +0100
--- ./src/pl/plperl/sql/plperl_trigger.sql	2010-09-04 11:13:40.000000000 +0100
***************
*** 60,65 ****
--- 60,79 ----
  delete from trigger_test;
  	  
  DROP TRIGGER show_trigger_data_trig on trigger_test;
+ 
+ insert into trigger_test values(1,'insert');
+ CREATE VIEW trigger_test_view AS SELECT * FROM trigger_test;
+ 
+ CREATE TRIGGER show_trigger_data_trig
+ INSTEAD OF INSERT OR UPDATE OR DELETE ON trigger_test_view
+ FOR EACH ROW EXECUTE PROCEDURE trigger_data(24,'skidoo view');
+ 
+ insert into trigger_test_view values(2,'insert');
+ update trigger_test_view set v = 'update' where i = 1;
+ delete from trigger_test_view;
+ 
+ DROP VIEW trigger_test_view;
+ delete from trigger_test;
  	  
  DROP FUNCTION trigger_data();
  
*** ./src/pl/plpgsql/src/pl_exec.c.orig	2010-08-28 17:29:02.000000000 +0100
--- ./src/pl/plpgsql/src/pl_exec.c	2010-08-30 23:37:49.000000000 +0100
***************
*** 581,588 ****
  		var->value = CStringGetTextDatum("BEFORE");
  	else if (TRIGGER_FIRED_AFTER(trigdata->tg_event))
  		var->value = CStringGetTextDatum("AFTER");
  	else
! 		elog(ERROR, "unrecognized trigger execution time: not BEFORE or AFTER");
  	var->isnull = false;
  	var->freeval = true;
  
--- 581,590 ----
  		var->value = CStringGetTextDatum("BEFORE");
  	else if (TRIGGER_FIRED_AFTER(trigdata->tg_event))
  		var->value = CStringGetTextDatum("AFTER");
+ 	else if (TRIGGER_FIRED_INSTEAD(trigdata->tg_event))
+ 		var->value = CStringGetTextDatum("INSTEAD OF");
  	else
! 		elog(ERROR, "unrecognized trigger execution time: not BEFORE, AFTER or INSTEAD OF");
  	var->isnull = false;
  	var->freeval = true;
  
*** ./src/pl/plpython/plpython.c.orig	2010-08-28 17:30:36.000000000 +0100
--- ./src/pl/plpython/plpython.c	2010-08-30 23:39:52.000000000 +0100
***************
*** 846,851 ****
--- 846,853 ----
  			pltwhen = PyString_FromString("BEFORE");
  		else if (TRIGGER_FIRED_AFTER(tdata->tg_event))
  			pltwhen = PyString_FromString("AFTER");
+ 		else if (TRIGGER_FIRED_INSTEAD(tdata->tg_event))
+ 			pltwhen = PyString_FromString("INSTEAD OF");
  		else
  		{
  			elog(ERROR, "unrecognized WHEN tg_event: %u", tdata->tg_event);
*** ./src/pl/plpython/sql/plpython_trigger.sql.orig	2010-09-04 11:22:22.000000000 +0100
--- ./src/pl/plpython/sql/plpython_trigger.sql	2010-09-04 11:33:54.000000000 +0100
***************
*** 99,106 ****
  delete from trigger_test;
  truncate table trigger_test;
  
! DROP FUNCTION trigger_data() CASCADE;
  
  
  --
  -- trigger error handling
--- 99,122 ----
  delete from trigger_test;
  truncate table trigger_test;
  
! DROP TRIGGER show_trigger_data_trig_stmt on trigger_test;
! DROP TRIGGER show_trigger_data_trig_before on trigger_test;
! DROP TRIGGER show_trigger_data_trig_after on trigger_test;
! 
! insert into trigger_test values(1,'insert');
! CREATE VIEW trigger_test_view AS SELECT * FROM trigger_test;
! 
! CREATE TRIGGER show_trigger_data_trig
! INSTEAD OF INSERT OR UPDATE OR DELETE ON trigger_test_view
! FOR EACH ROW EXECUTE PROCEDURE trigger_data(24,'skidoo view');
  
+ insert into trigger_test_view values(2,'insert');
+ update trigger_test_view set v = 'update' where i = 1;
+ delete from trigger_test_view;
+ 
+ DROP FUNCTION trigger_data() CASCADE;
+ DROP VIEW trigger_test_view;
+ delete from trigger_test;
  
  --
  -- trigger error handling
*** ./src/pl/tcl/pltcl.c.orig	2010-07-31 12:26:53.000000000 +0100
--- ./src/pl/tcl/pltcl.c	2010-08-30 23:40:13.000000000 +0100
***************
*** 822,827 ****
--- 822,829 ----
  			Tcl_DStringAppendElement(&tcl_cmd, "BEFORE");
  		else if (TRIGGER_FIRED_AFTER(trigdata->tg_event))
  			Tcl_DStringAppendElement(&tcl_cmd, "AFTER");
+ 		else if (TRIGGER_FIRED_INSTEAD(trigdata->tg_event))
+ 			Tcl_DStringAppendElement(&tcl_cmd, "INSTEAD OF");
  		else
  			elog(ERROR, "unrecognized WHEN tg_event: %u", trigdata->tg_event);
  
*** ./src/pl/tcl/sql/pltcl_queries.sql.orig	2010-09-04 11:37:44.000000000 +0100
--- ./src/pl/tcl/sql/pltcl_queries.sql	2010-09-04 22:01:02.000000000 +0100
***************
*** 76,80 ****
--- 76,85 ----
  
  -- show dump of trigger data
  insert into trigger_test values(1,'insert');
+ 
+ insert into trigger_test_view values(2,'insert');
+ update trigger_test_view set v = 'update' where i=1;
+ delete from trigger_test_view;
+ 
  update trigger_test set v = 'update' where i = 1;
  delete from trigger_test;
*** ./src/pl/tcl/sql/pltcl_setup.sql.orig	2010-09-04 11:37:22.000000000 +0100
--- ./src/pl/tcl/sql/pltcl_setup.sql	2010-09-04 11:42:59.000000000 +0100
***************
*** 60,65 ****
--- 60,67 ----
  CREATE TABLE trigger_test
      (i int, v text );
  
+ CREATE VIEW trigger_test_view AS SELECT * FROM trigger_test;
+ 
  CREATE FUNCTION trigger_data() returns trigger language pltcl as $_$
  
  	if { [info exists TG_relid] } {
***************
*** 96,101 ****
--- 98,106 ----
  BEFORE INSERT OR UPDATE OR DELETE ON trigger_test
  FOR EACH ROW EXECUTE PROCEDURE trigger_data(23,'skidoo');
  
+ CREATE TRIGGER show_trigger_data_view_trig
+ INSTEAD OF INSERT OR UPDATE OR DELETE ON trigger_test_view
+ FOR EACH ROW EXECUTE PROCEDURE trigger_data(24,'skidoo view');
  
  --
  -- Trigger function on every change to T_pkey1
